/*
 It's a calculator!
 This program takes as input a string which consists of a series of
 expressions. An example:

 8 * (2-4) / -6 + 4
 a = 3*5.6 + 6/.7
 b = a+3.567
 car = 38 - 76 * (hg = b * a)

 For each line (expression), the result is printed.
 Numbers are stored as float variables so corresponding limitations apply.

 Reference :
	Desk calculator program
	The C++ Programming Language
	By Bjarne Stroustrup(1998).

 Programmer : Gaurang Ramakent Khetan 		Dated: 16/08/1998

*/

#include <CONIO.H>
#include <STDLIB.H>
#include <CTYPE.H>
#include <STRING.H>

#define forever for(;;)
const int MAX_INPUT = 100;		// maximum letters of input
const int MAX_VAR = 25;       // maximum number of variables
const int MAX_VAR_LEN = 32;	// maximum length of variables
const int TRUE = 1;
const int FALSE = 0;

void error(const char*);	//global error handler

enum token_types {  NUMBER, STRING, END, EOS, ASSIGN = '=',
						  MULTIPLY = '*', ADD = '+', DIVIDE = '/',
						  SUBTRACT = '-', LP = '(', RP = ')'  			};

#include "CALC.H"    //class defs and member funct defs

void main()
	{
	parser parse;

	clrscr();

	int no_of_expressions = parse.take_input();

	for(int i=1; i<=no_of_expressions; i++)
		cprintf("\r\n Result of line no.%d = %f", i, parse.expression());

	getch();

	parse.destroy();
	}

void error(const char* str)
	{
	cputs("\r\n ERROR: ");
	cputs(str);
	getch();
	exit(1);
	}

